Lanes::API.routes.for_extension 'lanes' do

    get 'job-statuses/:id.json' do
        wrap_reply do
            status = Lanes::Job.status_for_id(params[:id])
            raise ActiveRecord::RecordNotFound unless status
            std_api_reply :update, status, success: true
        end
    end

    get 'screens.json', &Lanes::API::Handlers::Screens.get

    post "user-sessions.json", &Lanes::API::Handlers::UserSession.create
    get "user-sessions/test.json", &Lanes::API::Handlers::UserSession.check

    delete "user-sessions/:id.json" do
        wrap_reply do
            { success: true, message: "Logout succeeded", data: {}, token: '' }
        end
    end

    resources Lanes::User

end
